Index: uspace/lib/meson.build
===================================================================
--- uspace/lib/meson.build	(revision 4d58bac13740feb52caf7dd9407350d098012a56)
+++ uspace/lib/meson.build	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -80,4 +80,5 @@
 	'scsi',
 	'sif',
+	'startmenu',
 	'trackmod',
 	'untar',
Index: uspace/lib/startmenu/doc/doxygroups.h
===================================================================
--- uspace/lib/startmenu/doc/doxygroups.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/doc/doxygroups.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,3 @@
+/** @addtogroup libstartmenu libstartmenu
+ * @ingroup libs
+ */
Index: uspace/lib/startmenu/include/startmenu/startmenu.h
===================================================================
--- uspace/lib/startmenu/include/startmenu/startmenu.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/include/startmenu/startmenu.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libstartmenu
+ * @{
+ */
+/**
+ * @file Start menu
+ */
+
+#ifndef _STARTMENU_STARTMENU_H
+#define _STARTMENU_STARTMENU_H
+
+#include <errno.h>
+#include <types/startmenu/startmenu.h>
+
+extern errno_t startmenu_open(const char *, startmenu_t **);
+extern void startmenu_close(startmenu_t *);
+extern startmenu_entry_t *startmenu_first(startmenu_t *);
+extern startmenu_entry_t *startmenu_next(startmenu_entry_t *);
+extern const char *startmenu_entry_get_caption(startmenu_entry_t *);
+extern const char *startmenu_entry_get_cmd(startmenu_entry_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/startmenu/include/types/startmenu/startmenu.h
===================================================================
--- uspace/lib/startmenu/include/types/startmenu/startmenu.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/include/types/startmenu/startmenu.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libstartmenu
+ * @{
+ */
+/**
+ * @file Start menu
+ */
+
+#ifndef _STARTMENU_TYPES_STARTMENU_H
+#define _STARTMENU_TYPES_STARTMENU_H
+
+struct startmenu;
+typedef struct startmenu startmenu_t;
+
+struct startmenu_entry;
+typedef struct startmenu_entry startmenu_entry_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/startmenu/meson.build
===================================================================
--- uspace/lib/startmenu/meson.build	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/meson.build	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2023 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+deps = [ 'sif' ]
+src = files(
+	'src/startmenu.c',
+)
+
+test_src = files(
+	'test/main.c',
+	'test/startmenu.c',
+)
Index: uspace/lib/startmenu/private/startmenu.h
===================================================================
--- uspace/lib/startmenu/private/startmenu.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/private/startmenu.h	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libstartmenu
+ * @{
+ */
+/**
+ * @file Start menu
+ *
+ */
+
+#ifndef _STARTMENU_PRIVATE_STARTMENU_H
+#define _STARTMENU_PRIVATE_STARTMENU_H
+
+#include <adt/list.h>
+#include <sif.h>
+#include <types/startmenu/startmenu.h>
+
+/** Start menu */
+struct startmenu {
+	/** List of entries (startmenu_entry_t) */
+	list_t entries;
+};
+
+/** Start menu entry */
+struct startmenu_entry {
+	/** Containing start menu */
+	struct startmenu *smenu;
+	/** Link to @c smenu->entries */
+	link_t lentries;
+	/** Entry caption (with accelerator markup) */
+	char *caption;
+	/** Command to run */
+	char *cmd;
+};
+
+extern errno_t startmenu_entry_create(startmenu_t *, const char *,
+    const char *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/startmenu/src/startmenu.c
===================================================================
--- uspace/lib/startmenu/src/startmenu.c	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/src/startmenu.c	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,226 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libstartmenu
+ * @{
+ */
+/**
+ * @file Start menu
+ */
+
+#include <errno.h>
+#include <sif.h>
+#include <startmenu/startmenu.h>
+#include <stdlib.h>
+#include <str.h>
+#include "../private/startmenu.h"
+
+/** Open start menu.
+ *
+ * @param repopath Pathname of the menu repository
+ * @param rsmenu Place to store pointer to start menu
+ * @return EOK on success or an error code
+ */
+errno_t startmenu_open(const char *repopath, startmenu_t **rsmenu)
+{
+	startmenu_t *smenu;
+	sif_sess_t *repo = NULL;
+	sif_node_t *rnode;
+	sif_node_t *nentries;
+	sif_node_t *nentry;
+	const char *ntype;
+	const char *caption;
+	const char *cmd;
+	errno_t rc;
+
+	smenu = calloc(1, sizeof(startmenu_t));
+	if (smenu == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	list_initialize(&smenu->entries);
+
+	rc = sif_open(repopath, &repo);
+	if (rc != EOK)
+		goto error;
+
+	rnode = sif_get_root(repo);
+	nentries = sif_node_first_child(rnode);
+	ntype = sif_node_get_type(nentries);
+	if (str_cmp(ntype, "entries") != 0) {
+		rc = EIO;
+		goto error;
+	}
+
+	nentry = sif_node_first_child(nentries);
+	while (nentry != NULL) {
+		ntype = sif_node_get_type(nentry);
+		if (str_cmp(ntype, "entry") != 0) {
+			rc = EIO;
+			goto error;
+		}
+
+		caption = sif_node_get_attr(nentry, "caption");
+		if (caption == NULL) {
+			rc = EIO;
+			goto error;
+		}
+
+		cmd = sif_node_get_attr(nentry, "cmd");
+		if (cmd == NULL) {
+			rc = EIO;
+			goto error;
+		}
+
+		rc = startmenu_entry_create(smenu, caption, cmd);
+		if (rc != EOK)
+			goto error;
+
+		nentry = sif_node_next_child(nentry);
+	}
+
+	*rsmenu = smenu;
+	return EOK;
+error:
+	if (repo != NULL)
+		sif_close(repo);
+	if (smenu != NULL)
+		free(smenu);
+	return rc;
+}
+
+/** Close start menu.
+ *
+ * @param smenu Start menu
+ */
+void startmenu_close(startmenu_t *smenu)
+{
+}
+
+/** Get first start menu entry.
+ *
+ * @param smenu Start menu
+ * @return First entry or @c NULL if the menu is empty
+ */
+startmenu_entry_t *startmenu_first(startmenu_t *smenu)
+{
+	link_t *link;
+
+	link = list_first(&smenu->entries);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, startmenu_entry_t, lentries);
+}
+
+/** Get next start menu entry.
+ *
+ * @param cur Current entry
+ * @return Next entry or @c NULL if @a cur is the last entry
+ */
+startmenu_entry_t *startmenu_next(startmenu_entry_t *cur)
+{
+	link_t *link;
+
+	link = list_next(&cur->lentries, &cur->smenu->entries);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, startmenu_entry_t, lentries);
+}
+
+/** Get start menu entry caption.
+ *
+ * @param entry Start menu entry
+ * @return Caption (with accelerator markup)
+ */
+const char *startmenu_entry_get_caption(startmenu_entry_t *entry)
+{
+	return entry->caption;
+}
+
+/** Get start menu entry command.
+ *
+ * @param entr Start menu entry
+ * @return Command to run
+ */
+const char *startmenu_entry_get_cmd(startmenu_entry_t *entry)
+{
+	return entry->cmd;
+}
+
+/** Create a start menu entry and append it to the start menu (internal).
+ *
+ * This only creates the entry in memory, but does not update the repository.
+ *
+ * @param smenu Start menu
+ * @param caption Caption
+ * @param cmd Command to run
+ */
+errno_t startmenu_entry_create(startmenu_t *smenu, const char *caption,
+    const char *cmd)
+{
+	startmenu_entry_t *entry;
+	errno_t rc;
+
+	entry = calloc(1, sizeof(startmenu_entry_t));
+	if (entry == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	entry->caption = str_dup(caption);
+	if (entry->caption == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	entry->cmd = str_dup(cmd);
+	if (entry->cmd == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	entry->smenu = smenu;
+	list_append(&entry->lentries, &smenu->entries);
+	return EOK;
+error:
+	if (entry != NULL) {
+		if (entry->caption != NULL)
+			free(entry->caption);
+		if (entry->cmd != NULL)
+			free(entry->cmd);
+		free(entry);
+	}
+
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/lib/startmenu/test/main.c
===================================================================
--- uspace/lib/startmenu/test/main.c	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/test/main.c	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_IMPORT(startmenu);
+
+PCUT_MAIN();
Index: uspace/lib/startmenu/test/startmenu.c
===================================================================
--- uspace/lib/startmenu/test/startmenu.c	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
+++ uspace/lib/startmenu/test/startmenu.c	(revision 7d78e466a029ab433906e8bf0580eb75d143e4fd)
@@ -0,0 +1,131 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <startmenu/startmenu.h>
+#include <stdio.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(startmenu);
+
+/** Opening and closing start menu */
+PCUT_TEST(open_close)
+{
+	errno_t rc;
+	startmenu_t *smenu;
+	FILE *f;
+	int rv;
+
+	f = fopen("/tmp/test", "wt");
+	PCUT_ASSERT_NOT_NULL(f);
+
+	rv = fputs("[sif](){[entries](){}}", f);
+	PCUT_ASSERT_TRUE(rv >= 0);
+
+	rv = fclose(f);
+	PCUT_ASSERT_INT_EQUALS(0, rv);
+
+	rc = startmenu_open("/tmp/test", &smenu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	startmenu_close(smenu);
+}
+
+/** Iterating over start menu entries */
+PCUT_TEST(first_next)
+{
+	errno_t rc;
+	startmenu_t *smenu;
+	startmenu_entry_t *e;
+	FILE *f;
+	int rv;
+
+	f = fopen("/tmp/test", "wt");
+	PCUT_ASSERT_NOT_NULL(f);
+
+	rv = fputs("[sif](){[entries](){"
+	    "[entry]([caption]=[A][cmd]=[a]){}"
+	    "[entry]([caption]=[B][cmd]=[b]){}"
+	    "}}", f);
+	PCUT_ASSERT_TRUE(rv >= 0);
+
+	rv = fclose(f);
+	PCUT_ASSERT_INT_EQUALS(0, rv);
+
+	rc = startmenu_open("/tmp/test", &smenu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = startmenu_first(smenu);
+	PCUT_ASSERT_NOT_NULL(e);
+	e = startmenu_next(e);
+	PCUT_ASSERT_NOT_NULL(e);
+	e = startmenu_next(e);
+	PCUT_ASSERT_NULL(e);
+
+	startmenu_close(smenu);
+}
+
+/** Getting menu entry properties */
+PCUT_TEST(get_caption_cmd)
+{
+	errno_t rc;
+	startmenu_t *smenu;
+	startmenu_entry_t *e;
+	const char *caption;
+	const char *cmd;
+	FILE *f;
+	int rv;
+
+	f = fopen("/tmp/test", "wt");
+	PCUT_ASSERT_NOT_NULL(f);
+
+	rv = fputs("[sif](){[entries](){"
+	    "[entry]([caption]=[A][cmd]=[a]){}"
+	    "}}", f);
+	PCUT_ASSERT_TRUE(rv >= 0);
+
+	rv = fclose(f);
+	PCUT_ASSERT_INT_EQUALS(0, rv);
+
+	rc = startmenu_open("/tmp/test", &smenu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = startmenu_first(smenu);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	caption = startmenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = startmenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+
+	startmenu_close(smenu);
+}
+
+PCUT_EXPORT(startmenu);
